<template>
  <q-toolbar class="bg-primary text-white raised">
    <q-toolbar-title>Assertions
      <q-badge align="top" outline v-if="assertions">
        {{ assertions_filtered.length }}
      </q-badge>
      <q-badge align="top" outline v-else>0</q-badge>
    </q-toolbar-title>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="filter" v-model="search_value">
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
      </q-input>
    </q-card-section>
  </q-card>

  <q-list bordered class="detail--padding scroll_list">
    <q-item clickable v-ripple
            v-for="(assertion, index) in assertions_filtered"
            v-bind:id="assertion.id"
            v-bind:key="index"
            active-class="active"
            :dts_name="dts_name"
            :to="{name: 'assertion_detail',
                    params: {assertion_id: assertion.id}}">
      <q-item-section>
        <q-item-label>{{ formatted_id(assertion.id) }}</q-item-label>
      </q-item-section>
    </q-item>
    <q-inner-loading :showing="typeof this.assertions=='undefined'">
      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof this.assertions=='undefined'"></q-circular-progress>
    </q-inner-loading>

  </q-list>

</template>

<script>
import {api} from 'boot/axios'
import _ from 'lodash'

export default {
  name: "AssertionList",
  created() {
    this.fetchData()
  },
  data() {
    return {
      assertions: undefined,
      search_value: '',
    }
  },
  props: {
    dts_name: String,
    nt_version: String
  },
  methods: {
    fetchData: function () {
      api
        .get("/dts/" + this.dts_name + "/assertions",
          {params: {nt_version: this.nt_version, full: 0}})
        .then(response => {
          this.assertions = response.data
          if (this.assertions.length && this.$route.fullPath.endsWith('assertions')) {
            this.$router.push({
              name: 'assertion_detail',
              replace: true,
              params: {assertion_id: this.assertions[0].id}
            })
          } else {
            this.$nextTick(() => {
              this.scroll_to_active()
            })
          }
        })
    },
    formatted_id: function (assertion_id) {
      return assertion_id.replaceAll("_", " ")
    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    }

  },
  computed: {
    assertions_filtered() {
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        return this.assertions.filter(assertion => assertion.id &&
          assertion.id.toLowerCase().includes(this.search_value.toLowerCase()))
      } else {
        return this.assertions
      }
    }
  }
}
</script>

<style scoped lang="scss">
.active {
  background: $list_selected_bg;
  color: white;
  opacity: 0.9;
}

.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 290px);
}

</style>
